
/* ===================  AnyDBM  ===============================
Copyright (C) 1998, WebThing Ltd
Author: Nick Kew

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

-------------
Author/Copyright Holder Information: please see the README file and
the AnyDBM webpages at <URL:http://www.webthing.com/software/AnyDBM/>

============================================================ */
#ifndef DB_BTREE_H
#define DB_BTREE_H

#define RDBM_DB_1_85_FILE "/var/AnyDBM/rdbm.db_1_85.btree"

#include "DB_1_85.h"

template <class T>
class DB_1_85_BTREE : public DB_1_85<T> {
public:
  DB_1_85_BTREE() ;
  virtual ~DB_1_85_BTREE() {} ;
private:
  struct BTREEINFO _info ;
} ;

template <class T>
inline DB_1_85_BTREE<T>::DB_1_85_BTREE() {
  char* name = getenv("ANYDBM_DB") ;
  if (!name) name = RDBM_DB_1_85_FILE ;

  bzero(&_info, sizeof(_info)) ;

  if (_fd = dbopen (name , O_RDWR|O_CREAT, 0600, DB_BTREE, &_info), !_fd)
    dbstatus = RDBM_OPEN_FAILED ;
}


#endif
