
/* ===================  AnyDBM  ===============================
Copyright (C) 1998, WebThing Ltd
Author: Nick Kew

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

-------------
Author/Copyright Holder Information: please see the README file and
the AnyDBM webpages at <URL:http://www.webthing.com/software/AnyDBM/>

============================================================ */
#include "RDBM.h"
#include "RDBM_C.h"


extern "C" {

rdbm_fd rdbm_open(const char* host, const int prog, const int vers) {
  return new RDBM<const char*>(host, prog, vers) ;
}
void rdbm_close(rdbm_fd fd) {
  delete fd ;
}
int rdbm_reconnect(rdbm_fd fd, const char* host, const int prog,
		const int vers) {
  return fd->reconnect(host, prog, vers) ;
}
int rdbm_put_new(rdbm_fd fd, const char* key, const char* val) {
  return fd->put_new(key, val) ;
}
int rdbm_put(rdbm_fd fd, const char* key, const char* val) {
  return fd->put(key, val) ;
}
int rdbm_del(rdbm_fd fd, const char* key) {
  return fd->del(key) ;
}
int rdbm_fetch(rdbm_fd fd, const char* key) {
  return fd->fetch(key) ;
}
int rdbm_nextkey(rdbm_fd fd, const char* key) {
  return fd->nextkey(key) ;
}
int rdbm_firstkey(rdbm_fd fd) {
  return fd->firstkey() ;
}
const char* rdbm_get(rdbm_fd fd, const char* key) {
  return fd->get(key) ;
}
const char* rdbm_seq(rdbm_fd fd, const char* key) {
  return fd->seq(key) ;
}
int rdbm_errnum(rdbm_fd fd) {
  return fd->errnum() ;
}
void rdbm_clearerr(rdbm_fd fd) {
  fd->clear_err() ;
}
const char* rdbm_errmsg(rdbm_fd fd) {
  return fd->errmsg() ;
}
const char* rdbm_lastval(rdbm_fd fd) {
  return fd->lastval() ;
}

}
