
/* ===================  AnyDBM  ===============================
Copyright (C) 1998, WebThing Ltd
Author: Nick Kew

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

-------------
Author/Copyright Holder Information: please see the README file and
the AnyDBM webpages at <URL:http://www.webthing.com/software/AnyDBM/>

============================================================ */
#ifndef TIE_H
#define TIE_H

class exception {} ;
#ifdef USEX
class badkeyexception : public exception {} ;
#endif
class dbmexception : public exception {
public:
  const int errnum ;
  dbmexception(const int n) : errnum(n) {}
} ;

class NullTiedObject {		// gcc gives internal compiler error if
public:				// we really make this null
  NullTiedObject() {}
} ;

#include "TiedObject.h"
#include "TiedArray.h"

/* To shoehorn your type into a TiedObject, inherit from a TiedObjectType
   and instantiate the functions
*/
class TiedObjectType {
public:
  virtual operator const char*() const = 0 ;
  virtual operator char*() = 0 ;
  virtual bool operator!() { return (const char*)(*this) != 0 ; }
  virtual const bool operator!() const { return (const char*)(*this) != 0 ; }
  virtual TiedObjectType& operator=(const char* arg) = 0 ;
  TiedObjectType(const char*) {}
  TiedObjectType() {}
  virtual ~TiedObjectType() {}
} ;
#endif
