
/* ===================  AnyDBM  ===============================
Copyright (C) 1998, WebThing Ltd
Author: Nick Kew

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

-------------
Author/Copyright Holder Information: please see the README file and
the AnyDBM webpages at <URL:http://www.webthing.com/software/AnyDBM/>

============================================================ */
/* rdbm.x:
*/

/* Banner comment for generated files */
%/********************************************************
%  This file is automatically generated by rpcgen, and is
%  not source code.   Its source code is rdbm.x
%*********************************************************/

/* make header 'safe' against double-inclusion */
#ifdef RPC_HDR
%#ifndef RDBM_H
%#define RDBM_H
%#include <rpc.h>
#endif

/* constants determining the size of the data buffers
   passed between client & server
*/
#include "rdbm.const"

/* basic components of RPC call data buffers */
/* typedef char rdbm_db_t[rdbm_max_name] ;	*/	/* DB Name */
typedef char rdbm_kbuf_t[rdbm_max_key] ;		/* DB Key buf */
typedef char rdbm_data_t[rdbm_max_data] ;	/* DB data buf */

%#ifndef NO_SAFE_LIST
struct rdbm_ident_t {
	int pid ;
	int host ;
} ;
%#else
%typedef void rdbm_ident_t
%#endif

struct rdbm_key_t {
%#ifndef NO_SAFE_LIST
	rdbm_ident_t id ;
%#endif
	rdbm_kbuf_t key ;
} ;
struct rdbm_key_val_t {
%#ifndef NO_SAFE_LIST
	rdbm_ident_t id ;
%#endif
	rdbm_kbuf_t key ;
	rdbm_data_t val ;
} ;

/* The RPC function call interface:
   
*/
program RDBM_P {
 version RDBM_V {
  string RDBM_GET(rdbm_key_t) = 2 ;
  int RDBM_PUT(rdbm_key_val_t) = 3 ;
  int RDBM_PUT_NEW(rdbm_key_val_t) = 4 ;
  int RDBM_DEL(rdbm_key_t) = 5 ;
  int RDBM_SYNC(rdbm_ident_t) = 9 ;
  string RDBM_SEQ(rdbm_key_t) = 11 ;
 } = rdbm_v ;
} = rdbm_p ;

#ifdef RPC_HDR
%#endif
#endif
